sealed abstract class Tree {
	def size:Int = this match {
		case E() => 0
		case T(l:Tree,e:Int,r:Tree) => 
			1 + l.size + r.size
	}
	def depth:Int = this match {
		case E() => 0
		case T(l:Tree,e:Int,r:Tree) =>
			1 + (l.depth max r.depth)
	}
}
case class E() extends Tree
case class T(l:Tree,e:Int,r:Tree) extends Tree

object Tree extends App {
	val e = E()
	val t = T(T(E(),5,E()),10,E())
	println(e.size) // stampa 0
	println(t.size) // stampa 2
	println(e.depth) // stampa 0
	println(t.depth) // stampa 2
}
