sealed abstract class Tree
case class E() extends Tree
case class T(l:Tree,e:Int,r:Tree) extends Tree

def size(t:Tree):Int = t match {
	case E() => 0
	case T(l:Tree, e:Int, r:Tree) => 1+size(l)+size(r)
}

def equal(t1:Tree,t2:Tree):Boolean = {
	(t1,t2) match {
		case (E(),E()) => true
		case (_, E()) => false
		case (E(),_) => false
		case (T(l1,e1,r1),T(l2,e2,r2)) => {
			e1==e2 && equal(l1,l2) && equal(r1,r2)
		}
	}
}